=== modified file 'config/pandora-plugin'
--- config/pandora-plugin	2011-01-18 17:18:53 +0000
+++ config/pandora-plugin	2011-01-19 00:14:08 +0000
@@ -1,6 +1,7 @@
 #!/usr/bin/python
 
 #  Copyright (C) 2009 Sun Microsystems, Inc.
+#  Copyright (C) 2010, 2011 Monty Taylor
 #
 #  This program is free software; you can redistribute it and/or modify
 #  it under the terms of the GNU General Public License as published by
@@ -243,6 +244,19 @@
     with_%(name)s_plugin="%(enabled)s"
     requested_%(name)s_plugin="no"
   ])
+AC_ARG_WITH([static-%(name_with_dashes)s-plugin],[
+AS_HELP_STRING([--with-static-%(name_with_dashes)s-plugin],[Build Archive Storage Engine. @<:@default=%(static_yesno)s@:>@])
+AS_HELP_STRING([--without-static-%(name_with_dashes)s-plugin],[Disable building Archive Storage Engine])
+  ],[
+    with_static_%(name)s_plugin=${withval}
+  ],[
+    with_static_%(name)s_plugin=%(static_yesno)s
+])
+AS_IF([test "x${with_static_%(name)s_plugin}" = "xyes" -o "x${with_all_static}" = "xyes"],[
+  shared_%(name)s_plugin=no
+  ],[
+  shared_%(name)s_plugin=yes
+])
 AC_ARG_ENABLE([%(name_with_dashes)s-plugin],[
 dnl indented wierd to make the help output correct
 AS_HELP_STRING([--enable-%(name_with_dashes)s-plugin],[Enable loading %(title)s by default. @<:@default=%(default_yesno)s@:>@])
@@ -272,20 +286,24 @@
 """ % plugin)
   if not plugin['unconditional']:
     plugin_ac.write("""
+AM_CONDITIONAL([%(static_build_conditional_tag)s],
+               [test %(build_conditional)s -a ! %(shared_build)s])
+AM_CONDITIONAL([%(shared_build_conditional_tag)s],
+               [test %(build_conditional)s -a %(shared_build)s])
 AM_CONDITIONAL([%(build_conditional_tag)s],
                [test %(build_conditional)s])
     """ % plugin)
 
   plugin_ac.write("""
-AS_IF([test "x$with_%(name)s_plugin" = "xyes"],
-    [
+AS_IF([test "x$with_%(name)s_plugin" = "xyes"],[
 """ % plugin)
   if plugin['testsuite']:
     plugin_ac.write("""
       pandora_plugin_test_list="%(name)s,${pandora_plugin_test_list}"
     """ % plugin)
-  if plugin['static']:
-    plugin_ac.write("""
+  plugin_ac.write("""
+      AS_IF([test "x${with_static_%(name)s_plugin}" = "xyes" -o "x${with_all_static}" = "xyes"],[
+
         AS_IF([test "x$enable_%(name)s_plugin" = "xyes"],[
           pandora_builtin_load_list="%(module_name)s,${pandora_builtin_load_list}"
           pandora_builtin_load_symbols_list="_drizzled_%(module_name)s_plugin_,${pandora_builtin_load_symbols_list}"
@@ -294,15 +312,13 @@
         pandora_builtin_list="%(module_name)s,${pandora_builtin_list}"
         pandora_builtin_symbols_list="_drizzled_%(module_name)s_plugin_,${pandora_builtin_symbols_list}"
         pandora_plugin_libs="${pandora_plugin_libs} \${top_builddir}/%(root_plugin_dir)s/%(libname)s.la"
-    """ % plugin)
-
-  else:
-    plugin_ac.write("""
+     ],[
         AS_IF([test "x$enable_%(name)s_plugin" = "xyes"],[
           pandora_default_plugin_list="%(name)s,${pandora_default_plugin_list}"
         ])
+    ])
     """ % plugin)
-  plugin_ac.write("      ])\n")
+  plugin_ac.write("])\n")
 
 def fix_file_paths(plugin, files):
   # TODO: determine path to plugin dir relative to top_srcdir... append it to
@@ -347,7 +363,13 @@
       plugin['extra_dist']=" ".join([os.path.join(plugin['rel_path'],f) for f in plugin['extra_dist'].split()])
 
 
+    if plugin['static']:
+      plugin['static_yesno']="yes"
+    else:
+      plugin['static_yesno']="no"
     plugin['build_conditional_tag']= "BUILD_%s_PLUGIN" % plugin['name'].upper()
+    plugin['shared_build_conditional_tag']= "BUILD_%s_PLUGIN_SHARED" % plugin['name'].upper()
+    plugin['static_build_conditional_tag']= "BUILD_%s_PLUGIN_STATIC" % plugin['name'].upper()
     plugin['name_with_dashes']= plugin['name'].replace('_','-')
     if plugin.has_key('build_conditional'):
       plugin['has_build_conditional']=True
@@ -355,6 +377,7 @@
     else:
       plugin['has_build_conditional']=False
       plugin['build_conditional']='"x${with_%(name)s_plugin}" = "xyes"' %plugin
+    plugin['shared_build']='"x${shared_%(name)s_plugin}" = "xyes"' %plugin
 
     if plugin['install']:
       plugin['library_type']= 'pkgplugin'
@@ -518,11 +541,12 @@
     plugin_am.write("EXTRA_DIST += %(rel_path)s/%(dist_testsuite)s\n" % plugin)
   if plugin['docs'] is not None:
     plugin_am.write("EXTRA_DIST += ${top_srcdir}/%(rel_path)s/docs/*.rst\n" % plugin)
-  if plugin['static']:
-    plugin_am.write("""
+  plugin_am.write("""
 %(root_plugin_dir)s_%(plugin_prefix)s%(name)s_dir=${top_srcdir}/%(rel_path)s
-EXTRA_DIST += %(rel_path)s/plugin.ini
-if %(build_conditional_tag)s
+# Include sources in EXTRA_DIST because we might not build this, but we
+# still want the sources to wind up in a tarball
+EXTRA_DIST += %(rel_path)s/plugin.ini %(sources)s
+if %(static_build_conditional_tag)s
   noinst_LTLIBRARIES+=%(root_plugin_dir)s/%(libname)s.la
   %(root_plugin_dir)s_%(libname)s_la_LIBADD=%(libs)s
   %(root_plugin_dir)s_%(libname)s_la_DEPENDENCIES=%(libs)s
@@ -534,12 +558,8 @@
   check_PROGRAMS += %(tests)s
   PANDORA_DYNAMIC_LDADDS+=${top_builddir}/%(root_plugin_dir)s/%(libname)s.la
 endif
-""" % plugin)
-  else:
-    plugin_am.write("""
-%(root_plugin_dir)s_%(plugin_prefix)s%(name)s_dir=${top_srcdir}/%(rel_path)s
 EXTRA_DIST += %(rel_path)s/plugin.ini
-if %(build_conditional_tag)s
+if %(shared_build_conditional_tag)s
   %(library_type)s_LTLIBRARIES+=%(root_plugin_dir)s/%(libname)s.la
   %(root_plugin_dir)s_%(libname)s_la_LDFLAGS=-avoid-version -rpath $(pkgplugindir) $(AM_LDFLAGS) %(ldflags)s $(GCOV_LIBS)
   %(root_plugin_dir)s_%(libname)s_la_LIBADD=%(libs)s
@@ -662,6 +682,15 @@
 if not os.path.exists("config/pandora-plugin.ac") or "write" in actions:
   plugin_ac_file = ChangeProtectedFile(os.path.join('config', 'pandora-plugin.ac'))
   plugin_ac_file.write("dnl Generated file, run make to rebuild\n")
+  plugin_ac_file.write("""
+AC_ARG_WITH([all-static],[
+AS_HELP_STRING([--with-all-static],[Link all plugins staticly into the server @<:@default=no@:>@])
+],[
+    with_all_static="$withval"
+    ],[
+    with_all_static=no
+])
+  """)
 
 if os.path.exists("docs/plugins"):
   if not os.path.exists("docs/plugins/list.rst") or "write" in actions:

=== modified file 'drizzled/join.cc'
--- drizzled/join.cc	2011-01-08 10:35:13 +0000
+++ drizzled/join.cc	2011-01-17 07:58:22 +0000
@@ -728,7 +728,7 @@
   }
   if (group_list || tmp_table_param.sum_func_count)
   {
-    if (! hidden_group_fields && rollup.state == ROLLUP::STATE_NONE)
+    if (! hidden_group_fields && rollup.getState() == Rollup::STATE_NONE)
       select_distinct=0;
   }
   else if (select_distinct && tables - const_tables == 1)
@@ -792,7 +792,7 @@
   {
     Order *old_group_list;
     group_list= remove_constants(this, (old_group_list= group_list), conds,
-                                 rollup.state == ROLLUP::STATE_NONE,
+                                 rollup.getState() == Rollup::STATE_NONE,
                                  &simple_group);
     if (session->is_error())
     {
@@ -1985,7 +1985,7 @@
     If we are using rollup, we need a copy of the summary functions for
     each level
   */
-  if (rollup.state != ROLLUP::STATE_NONE)
+  if (rollup.getState() != Rollup::STATE_NONE)
     func_count*= (send_group_parts+1);
 
   group_parts= send_group_parts;
@@ -2048,18 +2048,18 @@
          ((Item_sum *)item)->depended_from() == select_lex))
       *func++= (Item_sum*) item;
   }
-  if (before_group_by && rollup.state == ROLLUP::STATE_INITED)
+  if (before_group_by && rollup.getState() == Rollup::STATE_INITED)
   {
-    rollup.state= ROLLUP::STATE_READY;
+    rollup.setState(Rollup::STATE_READY);
     if (rollup_make_fields(field_list, send_fields, &func))
       return true;     // Should never happen
   }
-  else if (rollup.state == ROLLUP::STATE_NONE)
+  else if (rollup.getState() == Rollup::STATE_NONE)
   {
     for (uint32_t i=0 ; i <= send_group_parts ;i++)
       sum_funcs_end[i]= func;
   }
-  else if (rollup.state == ROLLUP::STATE_READY)
+  else if (rollup.getState() == Rollup::STATE_READY)
     return(false);                         // Don't put end marker
   *func=0;          // End marker
   return(false);
@@ -2071,7 +2071,7 @@
   Item **ref_array;
 
   tmp_table_param.quick_group= 0; // Can't create groups in tmp table
-  rollup.state= ROLLUP::STATE_INITED;
+  rollup.setState(Rollup::STATE_INITED);
 
   /*
     Create pointers to the different sum function groups
@@ -2079,18 +2079,19 @@
   */
   tmp_table_param.group_parts= send_group_parts;
 
-  if (!(rollup.null_items= (Item_null_result**) session->alloc((sizeof(Item*) +
+  rollup.setNullItems((Item_null_result**) session->alloc((sizeof(Item*) +
                                                                 sizeof(Item**) +
                                                                 sizeof(List<Item>) +
                                                                 ref_pointer_array_size)
-                                                               * send_group_parts )))
+                                                               * send_group_parts ));
+  if (! rollup.getNullItems())
   {
     return 1;
   }
 
-  rollup.fields= (List<Item>*) (rollup.null_items + send_group_parts);
-  rollup.ref_pointer_arrays= (Item***) (rollup.fields + send_group_parts);
-  ref_array= (Item**) (rollup.ref_pointer_arrays+send_group_parts);
+  rollup.setFields((List<Item>*) (rollup.getNullItems() + send_group_parts));
+  rollup.setRefPointerArrays((Item***) (rollup.getFields() + send_group_parts));
+  ref_array= (Item**) (rollup.getRefPointerArrays()+send_group_parts);
 
   /*
     Prepare space for field list for the different levels
@@ -2098,10 +2099,10 @@
   */
   for (uint32_t i= 0 ; i < send_group_parts ; i++)
   {
-    rollup.null_items[i]= new (session->mem_root) Item_null_result();
-    List<Item> *rollup_fields= &rollup.fields[i];
+    rollup.getNullItems()[i]= new (session->mem_root) Item_null_result();
+    List<Item> *rollup_fields= &rollup.getFields()[i];
     rollup_fields->empty();
-    rollup.ref_pointer_arrays[i]= ref_array;
+    rollup.getRefPointerArrays()[i]= ref_array;
     ref_array+= all_fields.elements;
   }
 
@@ -2109,7 +2110,7 @@
   {
     for (uint32_t j= 0 ; j < fields_list.elements ; j++)
     {
-      rollup.fields[i].push_back(rollup.null_items[i]);
+      rollup.getFields()[i].push_back(rollup.getNullItems()[i]);
     }
   }
 
@@ -2219,8 +2220,8 @@
     uint32_t pos= send_group_parts - level -1;
     bool real_fields= 0;
     Item *item;
-    List_iterator<Item> new_it(rollup.fields[pos]);
-    Item **ref_array_start= rollup.ref_pointer_arrays[pos];
+    List_iterator<Item> new_it(rollup.getFields()[pos]);
+    Item **ref_array_start= rollup.getRefPointerArrays()[pos];
     Order *start_group;
 
     /* Point to first hidden field */
@@ -2321,11 +2322,11 @@
   for (uint32_t i= send_group_parts ; i-- > idx ; )
   {
     /* Get reference pointers to sum functions in place */
-    memcpy(ref_pointer_array, rollup.ref_pointer_arrays[i], ref_pointer_array_size);
+    memcpy(ref_pointer_array, rollup.getRefPointerArrays()[i], ref_pointer_array_size);
 
     if ((!having || having->val_int()))
     {
-      if (send_records < unit->select_limit_cnt && do_send_rows && result->send_data(rollup.fields[i]))
+      if (send_records < unit->select_limit_cnt && do_send_rows && result->send_data(rollup.getFields()[i]))
       {
         return 1;
       }
@@ -2362,13 +2363,13 @@
   for (uint32_t i= send_group_parts ; i-- > idx ; )
   {
     /* Get reference pointers to sum functions in place */
-    memcpy(ref_pointer_array, rollup.ref_pointer_arrays[i],
+    memcpy(ref_pointer_array, rollup.getRefPointerArrays()[i],
            ref_pointer_array_size);
     if ((!having || having->val_int()))
     {
       int write_error;
       Item *item;
-      List_iterator_fast<Item> it(rollup.fields[i]);
+      List_iterator_fast<Item> it(rollup.getFields()[i]);
       while ((item= it++))
       {
         if (item->type() == Item::NULL_ITEM && item->is_result_field())

=== modified file 'drizzled/join.h'
--- drizzled/join.h	2010-12-24 07:15:43 +0000
+++ drizzled/join.h	2011-01-17 07:58:22 +0000
@@ -180,7 +180,7 @@
   DrizzleLock *lock;
 
   Join *tmp_join; /**< copy of this Join to be used with temporary tables */
-  ROLLUP rollup;				/**< Used with rollup */
+  Rollup rollup;				/**< Used with rollup */
   DYNAMIC_ARRAY keyuse;
   Item::cond_result cond_value;
   Item::cond_result having_value;
@@ -306,7 +306,7 @@
     memset(&keyuse, 0, sizeof(keyuse));
     tmp_table_param.init();
     tmp_table_param.end_write_records= HA_POS_ERROR;
-    rollup.state= ROLLUP::STATE_NONE;
+    rollup.setState(Rollup::STATE_NONE);
   }
 
   /** 
@@ -395,7 +395,7 @@
     memset(&keyuse, 0, sizeof(keyuse));
     tmp_table_param.init();
     tmp_table_param.end_write_records= HA_POS_ERROR;
-    rollup.state= ROLLUP::STATE_NONE;
+    rollup.setState(Rollup::STATE_NONE);
   }
 
   int prepare(Item ***rref_pointer_array, 

=== modified file 'drizzled/sql_select.cc'
--- drizzled/sql_select.cc	2011-01-09 08:39:30 +0000
+++ drizzled/sql_select.cc	2011-01-17 07:58:22 +0000
@@ -3932,7 +3932,7 @@
               error=join->result->send_data(*join->fields) ? 1 : 0;
             join->send_records++;
           }
-          if (join->rollup.state != ROLLUP::STATE_NONE && error <= 0)
+          if (join->rollup.getState() != Rollup::STATE_NONE && error <= 0)
           {
             if (join->rollup_send_data((uint32_t) (idx+1)))
               error= 1;
@@ -4022,7 +4022,7 @@
             return NESTED_LOOP_ERROR;
           }
         }
-        if (join->rollup.state != ROLLUP::STATE_NONE)
+        if (join->rollup.getState() != Rollup::STATE_NONE)
         {
           if (join->rollup_write_data((uint32_t) (idx+1), table))
             return NESTED_LOOP_ERROR;

=== modified file 'drizzled/sql_select.h'
--- drizzled/sql_select.h	2011-01-12 21:31:39 +0000
+++ drizzled/sql_select.h	2011-01-17 07:58:22 +0000
@@ -56,14 +56,76 @@
 enum_nested_loop_state end_send_group(Join *join, JoinTable *join_tab, bool end_of_records);
 enum_nested_loop_state end_write_group(Join *join, JoinTable *join_tab, bool end_of_records);
 
-typedef struct st_rollup
+class Rollup
 {
+public:
   enum State { STATE_NONE, STATE_INITED, STATE_READY };
+
+  Rollup()
+  :
+  state(),
+  null_items(NULL),
+  ref_pointer_arrays(NULL),
+  fields()
+  {}
+  
+  Rollup(State in_state,
+         Item_null_result **in_null_items,
+         Item ***in_ref_pointer_arrays,
+         List<Item> *in_fields)
+  :
+  state(in_state),
+  null_items(in_null_items),
+  ref_pointer_arrays(in_ref_pointer_arrays),
+  fields(in_fields)
+  {}
+  
+  State getState() const
+  {
+    return state;
+  }
+
+  void setState(State in_state)
+  {
+    state= in_state;
+  }
+ 
+  Item_null_result **getNullItems() const
+  {
+    return null_items;
+  }
+
+  void setNullItems(Item_null_result **in_null_items)
+  {
+    null_items= in_null_items;
+  }
+
+  Item ***getRefPointerArrays() const
+  {
+    return ref_pointer_arrays;
+  }
+
+  void setRefPointerArrays(Item ***in_ref_pointer_arrays)
+  {
+    ref_pointer_arrays= in_ref_pointer_arrays;
+  }
+
+  List<Item> *getFields() const
+  {
+    return fields;
+  }
+
+  void setFields(List<Item> *in_fields)
+  {
+    fields= in_fields;
+  }
+  
+private:
   State state;
   Item_null_result **null_items;
   Item ***ref_pointer_arrays;
   List<Item> *fields;
-} ROLLUP;
+};
 
 } /* namespace drizzled */
 

=== modified file 'drizzled/transaction_services.h'
--- drizzled/transaction_services.h	2011-01-17 04:15:23 +0000
+++ drizzled/transaction_services.h	2011-01-19 00:14:51 +0000
@@ -72,58 +72,8 @@
    * Transaction and Statement messages, false otherwise.
    */
   bool shouldConstructMessages();
-  /**
-   * Method which returns the active Transaction message
-   * for the supplied Session.  If one is not found, a new Transaction
-   * message is allocated, initialized, and returned. It is possible that
-   * we may want to NOT increment the transaction id for a new Transaction
-   * object (e.g., splitting up Transactions into smaller chunks). The
-   * should_inc_trx_id flag controls if we do this.
-   *
-   * @param in_session The session processing the transaction
-   * @param should_inc_trx_id If true, increments the transaction id for a new trx
-   */
-  message::Transaction *getActiveTransactionMessage(Session *in_session,
-                                                    bool should_inc_trx_id= true);
-  /** 
-   * Method which attaches a transaction context
-   * the supplied transaction based on the supplied Session's
-   * transaction information.  This method also ensure the
-   * transaction message is attached properly to the Session object
-   *
-   * @param in_transaction The transaction message to initialize
-   * @param in_session The Session processing this transaction
-   * @param should_inc_trx_id If true, increments the transaction id for a new trx
-   */
-  void initTransactionMessage(message::Transaction &in_transaction,
-                              Session *in_session,
-                              bool should_inc_trx_id);
-  /** 
-   * Helper method which finalizes data members for the 
-   * supplied transaction's context.
-   *
-   * @param in_transaction The transaction message to finalize 
-   * @param in_session The Session processing this transaction
-   */
-  void finalizeTransactionMessage(message::Transaction &in_transaction, Session *in_session);
-  /**
-   * Helper method which deletes transaction memory and
-   * unsets Session's transaction and statement messages.
-   */
-  void cleanupTransactionMessage(message::Transaction *in_transaction,
-                                 Session *in_session);
 
   /**
-   * Helper method which initializes a Statement message
-   *
-   * @param statement The statement to initialize
-   * @param in_type The type of the statement
-   * @param in_session The session processing this statement
-   */
-  void initStatementMessage(message::Statement &statement,
-                            message::Statement::Type in_type,
-                            Session *in_session);
-  /**
    * Finalizes a Statement message and sets the Session's statement
    * message to NULL.
    *
@@ -132,103 +82,7 @@
    */
   void finalizeStatementMessage(message::Statement &statement,
                                 Session *in_session);
-  /** Helper method which returns an initialized Statement message for methods
-   * doing insertion of data.
-   *
-   * @param[in] in_session Pointer to the Session doing the processing
-   * @param[in] in_table Pointer to the Table object being inserted into
-   * @param[out] next_segment_id The next Statement segment id to be used
-   */
-  message::Statement &getInsertStatement(Session *in_session,
-                                         Table *in_table,
-                                         uint32_t *next_segment_id);
-
-  /**
-   * Helper method which initializes the header message for
-   * insert operations.
-   *
-   * @param[in,out] statement Statement message container to modify
-   * @param[in] in_session Pointer to the Session doing the processing
-   * @param[in] in_table Pointer to the Table being inserted into
-   */
-  void setInsertHeader(message::Statement &statement,
-                       Session *in_session,
-                       Table *in_table);
-  /**
-   * Helper method which returns an initialized Statement
-   * message for methods doing updates of data.
-   *
-   * @param[in] in_session Pointer to the Session doing the processing
-   * @param[in] in_table Pointer to the Table object being updated
-   * @param[in] old_record Pointer to the old data in the record
-   * @param[in] new_record Pointer to the new data in the record
-   * @param[out] next_segment_id The next Statement segment id to be used
-   */
-  message::Statement &getUpdateStatement(Session *in_session,
-                                         Table *in_table,
-                                         const unsigned char *old_record, 
-                                         const unsigned char *new_record,
-                                         uint32_t *next_segment_id);
-  /**
-   * Helper method which initializes the header message for
-   * update operations.
-   *
-   * @param[in,out] statement Statement message container to modify
-   * @param[in] in_session Pointer to the Session doing the processing
-   * @param[in] in_table Pointer to the Table being updated
-   * @param[in] old_record Pointer to the old data in the record
-   * @param[in] new_record Pointer to the new data in the record
-   */
-  void setUpdateHeader(message::Statement &statement,
-                       Session *in_session,
-                       Table *in_table,
-                       const unsigned char *old_record, 
-                       const unsigned char *new_record);
-  /**
-   * Helper method which returns an initialized Statement
-   * message for methods doing deletion of data.
-   *
-   * @param[in] in_session Pointer to the Session doing the processing
-   * @param[in] in_table Pointer to the Table object being deleted from
-   * @param[out] next_segment_id The next Statement segment id to be used
-   */
-  message::Statement &getDeleteStatement(Session *in_session,
-                                         Table *in_table,
-                                         uint32_t *next_segment_id);
-
-  /**
-   * Helper method which initializes the header message for
-   * insert operations.
-   *
-   * @param[in,out] statement Statement message container to modify
-   * @param[in] in_session Pointer to the Session doing the processing
-   * @param[in] in_table Pointer to the Table being deleted from
-   */
-  void setDeleteHeader(message::Statement &statement,
-                       Session *in_session,
-                       Table *in_table);
-  /** 
-   * Commits a normal transaction (see above) and pushes the transaction
-   * message out to the replicators.
-   *
-   * @param in_session Pointer to the Session committing the transaction
-   */
-  int commitTransactionMessage(Session *in_session);
-  /** 
-   * Marks the current active transaction message as being rolled back and
-   * pushes the transaction message out to replicators.
-   *
-   * @param in_session Pointer to the Session committing the transaction
-   */
-  void rollbackTransactionMessage(Session *in_session);
-  /**
-   * Rolls back the current statement, deleting the last Statement out of
-   * the current Transaction message.
-   *
-   * @note This depends on having clear statement boundaries (i.e., one
-   * Statement message per actual SQL statement.
-   */
-  void rollbackStatementMessage(Session *in_session);
+
   /**
    * Creates a new InsertRecord GPB message and pushes it to
    * replicators.
@@ -240,6 +94,7 @@
    * reversed bool return crap...fix that.
    */
   bool insertRecord(Session *in_session, Table *in_table);
+
   /**
    * Creates a new UpdateRecord GPB message and pushes it to
    * replicators.
@@ -253,6 +108,7 @@
                     Table *in_table, 
                     const unsigned char *old_record, 
                     const unsigned char *new_record);
+
   /**
    * Creates a new DeleteRecord GPB message and pushes it to
    * replicators.
@@ -264,27 +120,6 @@
   void deleteRecord(Session *in_session, Table *in_table, bool use_update_record= false);
 
   /**
-   * Used to undo effects of a failed statement.
-   *
-   * An SQL statement, like an UPDATE, that affects multiple rows could
-   * potentially fail mid-way through processing the rows. In such a case,
-   * the successfully modified rows that preceeded the failing row would
-   * have been added to the Statement message. This method is used for
-   * rolling back that change.
-   *
-   * @note
-   * This particular failure is seen on column constraint violations
-   * during a multi-row UPDATE and a multi-row INSERT..SELECT.
-   *
-   * @param in_session Pointer to the Session containing the Statement
-   * @param count The number of records to remove from Statement.
-   *
-   * @retval true Successfully removed 'count' records
-   * @retval false Failure
-   */
-  bool removeStatementRecords(Session *in_session, uint32_t count);
-
-  /**
    * Creates a CreateSchema Statement GPB message and adds it
    * to the Session's active Transaction GPB message for pushing
    * out to the replicator streams.
@@ -300,7 +135,7 @@
    * out to the replicator streams.
    *
    * @param[in] in_session Pointer to the Session which issued the statement
-   * @param[in] schema_name message::Schema message describing new schema
+   * @param[in] identifier Identifier for the schema to drop
    */
   void dropSchema(Session *in_session, identifier::Schema::const_reference identifier);
 
@@ -326,6 +161,7 @@
    * @param[in] table message::Table message describing new schema
    */
   void createTable(Session *in_session, const message::Table &table);
+
   /**
    * Creates a DropTable Statement GPB message and adds it
    * to the Session's active Transaction GPB message for pushing
@@ -338,6 +174,7 @@
   void dropTable(Session *in_session,
                  const identifier::Table &table,
                  bool if_exists);
+
   /**
    * Creates a TruncateTable Statement GPB message and adds it
    * to the Session's active Transaction GPB message for pushing
@@ -347,6 +184,7 @@
    * @param[in] in_table The Table being truncated
    */
   void truncateTable(Session *in_session, Table *in_table);
+
   /**
    * Creates a new RawSql GPB message and pushes it to 
    * replicators.
@@ -360,8 +198,8 @@
    * @param query Query string
    */
   void rawStatement(Session *in_session, const std::string &query);
+
   /* transactions: interface to plugin::StorageEngine functions */
-  int commitPhaseOne(Session *session, bool all);
   int rollbackTransaction(Session *session, bool all);
 
   /* transactions: these functions never call plugin::StorageEngine functions directly */
@@ -446,13 +284,12 @@
   void registerResourceForTransaction(Session *session,
                                       plugin::MonitoredInTransaction *monitored,
                                       plugin::TransactionalStorageEngine *engine);
+
   void registerResourceForTransaction(Session *session,
                                       plugin::MonitoredInTransaction *monitored,
                                       plugin::TransactionalStorageEngine *engine,
                                       plugin::XaResourceManager *resource_manager);
 
-  uint64_t getCurrentTransactionId(Session *session);
-
   void allocateNewTransactionId();
  
   /**************
@@ -482,10 +319,167 @@
 private:
 
   /**
+   * Method which returns the active Transaction message
+   * for the supplied Session.  If one is not found, a new Transaction
+   * message is allocated, initialized, and returned. It is possible that
+   * we may want to NOT increment the transaction id for a new Transaction
+   * object (e.g., splitting up Transactions into smaller chunks). The
+   * should_inc_trx_id flag controls if we do this.
+   *
+   * @param in_session The session processing the transaction
+   * @param should_inc_trx_id If true, increments the transaction id for a new trx
+   */
+  message::Transaction *getActiveTransactionMessage(Session *in_session,
+                                                    bool should_inc_trx_id= true);
+
+  /** 
+   * Method which attaches a transaction context
+   * the supplied transaction based on the supplied Session's
+   * transaction information.  This method also ensure the
+   * transaction message is attached properly to the Session object
+   *
+   * @param in_transaction The transaction message to initialize
+   * @param in_session The Session processing this transaction
+   * @param should_inc_trx_id If true, increments the transaction id for a new trx
+   */
+  void initTransactionMessage(message::Transaction &in_transaction,
+                              Session *in_session,
+                              bool should_inc_trx_id);
+  
+  /**
+   * Helper method which initializes a Statement message
+   *
+   * @param statement The statement to initialize
+   * @param in_type The type of the statement
+   * @param in_session The session processing this statement
+   */
+  void initStatementMessage(message::Statement &statement,
+                            message::Statement::Type in_type,
+                            Session *in_session);
+
+  /** 
+   * Helper method which finalizes data members for the 
+   * supplied transaction's context.
+   *
+   * @param in_transaction The transaction message to finalize 
+   * @param in_session The Session processing this transaction
+   */
+  void finalizeTransactionMessage(message::Transaction &in_transaction, Session *in_session);
+
+  /**
+   * Helper method which deletes transaction memory and
+   * unsets Session's transaction and statement messages.
+   */
+  void cleanupTransactionMessage(message::Transaction *in_transaction,
+                                 Session *in_session);
+  
+  /** Helper method which returns an initialized Statement message for methods
+   * doing insertion of data.
+   *
+   * @param[in] in_session Pointer to the Session doing the processing
+   * @param[in] in_table Pointer to the Table object being inserted into
+   * @param[out] next_segment_id The next Statement segment id to be used
+   */
+  message::Statement &getInsertStatement(Session *in_session,
+                                         Table *in_table,
+                                         uint32_t *next_segment_id);
+  
+  /**
+   * Helper method which initializes the header message for
+   * insert operations.
+   *
+   * @param[in,out] statement Statement message container to modify
+   * @param[in] in_session Pointer to the Session doing the processing
+   * @param[in] in_table Pointer to the Table being inserted into
+   */
+  void setInsertHeader(message::Statement &statement,
+                       Session *in_session,
+                       Table *in_table);
+  /**
+   * Helper method which returns an initialized Statement
+   * message for methods doing updates of data.
+   *
+   * @param[in] in_session Pointer to the Session doing the processing
+   * @param[in] in_table Pointer to the Table object being updated
+   * @param[in] old_record Pointer to the old data in the record
+   * @param[in] new_record Pointer to the new data in the record
+   * @param[out] next_segment_id The next Statement segment id to be used
+   */
+  message::Statement &getUpdateStatement(Session *in_session,
+                                         Table *in_table,
+                                         const unsigned char *old_record, 
+                                         const unsigned char *new_record,
+                                         uint32_t *next_segment_id);
+  /**
+   * Helper method which initializes the header message for
+   * update operations.
+   *
+   * @param[in,out] statement Statement message container to modify
+   * @param[in] in_session Pointer to the Session doing the processing
+   * @param[in] in_table Pointer to the Table being updated
+   * @param[in] old_record Pointer to the old data in the record
+   * @param[in] new_record Pointer to the new data in the record
+   */
+  void setUpdateHeader(message::Statement &statement,
+                       Session *in_session,
+                       Table *in_table,
+                       const unsigned char *old_record, 
+                       const unsigned char *new_record);
+
+  /**
+   * Helper method which returns an initialized Statement
+   * message for methods doing deletion of data.
+   *
+   * @param[in] in_session Pointer to the Session doing the processing
+   * @param[in] in_table Pointer to the Table object being deleted from
+   * @param[out] next_segment_id The next Statement segment id to be used
+   */
+  message::Statement &getDeleteStatement(Session *in_session,
+                                         Table *in_table,
+                                         uint32_t *next_segment_id);
+  
+  /**
+   * Helper method which initializes the header message for
+   * insert operations.
+   *
+   * @param[in,out] statement Statement message container to modify
+   * @param[in] in_session Pointer to the Session doing the processing
+   * @param[in] in_table Pointer to the Table being deleted from
+   */
+  void setDeleteHeader(message::Statement &statement,
+                       Session *in_session,
+                       Table *in_table);
+
+  /** 
+   * Commits a normal transaction (see above) and pushes the transaction
+   * message out to the replicators.
+   *
+   * @param in_session Pointer to the Session committing the transaction
+   */
+  int commitTransactionMessage(Session *in_session);
+
+  /** 
+   * Marks the current active transaction message as being rolled back and
+   * pushes the transaction message out to replicators.
+   *
+   * @param in_session Pointer to the Session committing the transaction
+   */
+  void rollbackTransactionMessage(Session *in_session);
+
+  /**
+   * Rolls back the current statement, deleting the last Statement out of
+   * the current Transaction message.
+   *
+   * @note This depends on having clear statement boundaries (i.e., one
+   * Statement message per actual SQL statement.
+   */
+  void rollbackStatementMessage(Session *in_session);
+
+  /**
    * Checks if a field has been updated 
    *
    * @param current_field Pointer to the field to check if it is updated 
-   * @in_table Pointer to the Table containing update information
+   * @param in_table Pointer to the Table containing update information
    * @param old_record Pointer to the raw bytes representing the old record/row
    * @param new_record Pointer to the raw bytes representing the new record/row
    */
@@ -525,6 +519,10 @@
   message::Transaction *segmentTransactionMessage(Session *in_session,
                                                   message::Transaction *transaction);
 
+  int commitPhaseOne(Session *session, bool all);
+
+  uint64_t getCurrentTransactionId(Session *session);
+
   plugin::XaStorageEngine *xa_storage_engine;
 };
 

=== modified file 'm4/pandora_warnings.m4'
--- m4/pandora_warnings.m4	2011-01-17 21:33:14 +0000
+++ m4/pandora_warnings.m4	2011-01-18 17:54:23 +0000
@@ -372,6 +372,7 @@
       PROTOSKIP_WARNINGS="-Wno-effc++ -Wno-shadow -Wno-missing-braces ${NO_ATTRIBUTES}"
       NO_WERROR="-Wno-error"
       PERMISSIVE_WARNINGS="-Wno-error -Wno-unused-function -fpermissive"
+      PERMISSIVE_C_WARNINGS="-Wno-error -Wno-redundant-decls"
       AS_IF([test "$host_vendor" = "apple"],[
         BOOSTSKIP_WARNINGS="-Wno-uninitialized"
       ])
@@ -434,6 +435,7 @@
   AC_SUBST(INNOBASE_SKIP_WARNINGS)
   AC_SUBST(BOOSTSKIP_WARNINGS)
   AC_SUBST(PERMISSIVE_WARNINGS)
+  AC_SUBST(PERMISSIVE_C_WARNINGS)
   AC_SUBST(NO_WERROR)
   AC_SUBST([GCOV_LIBS])
 

=== modified file 'plugin/innobase/plugin.am'
--- plugin/innobase/plugin.am	2011-01-17 21:33:14 +0000
+++ plugin/innobase/plugin.am	2011-01-18 17:54:23 +0000
@@ -320,7 +320,7 @@
 # and unused/undefeind stuf, but are generated anyway 
 plugin_innobase_libpars_la_CFLAGS= \
 				   ${AM_CFLAGS} \
-				   ${PERMISSIVE_WARNINGS} \
+				   ${PERMISSIVE_C_WARNINGS} \
 				   -DUNIV_NONINL \
 				   -I$(top_builddir)/plugin/innobase/include \
 				   -I$(top_srcdir)/plugin/innobase/include \

=== modified file 'plugin/transaction_log/print_transaction_message.cc'
--- plugin/transaction_log/print_transaction_message.cc	2010-12-18 04:43:40 +0000
+++ plugin/transaction_log/print_transaction_message.cc	2011-01-14 20:12:02 +0000
@@ -184,16 +184,6 @@
   string transaction_text;
   protobuf::TextFormat::PrintToString(transaction_message, &transaction_text);
 
-  std::string::size_type begin_uuid;
-  while ((begin_uuid= transaction_text.find("uuid")) != string::npos)
-  {
-    std::string::size_type end_uuid= transaction_text.find('\n', begin_uuid); 
-    if (end_uuid != string::npos)
-    {
-      transaction_text.erase(begin_uuid, end_uuid - begin_uuid);
-    }
-  }
-
   if (str->alloc(transaction_text.length()))
   {
     delete coded_input;

=== modified file 'plugin/transaction_log/tests/r/bulk_commit.result'
--- plugin/transaction_log/tests/r/bulk_commit.result	2011-01-11 20:37:44 +0000
+++ plugin/transaction_log/tests/r/bulk_commit.result	2011-01-17 00:17:53 +0000
@@ -73,7 +73,7 @@
       CREATE_TIMESTAMP
       UPDATE_TIMESTAMP
       catalog: "LOCAL"
-      
+      UUID
       version: 1
     }
   }

=== modified file 'plugin/transaction_log/tests/r/bulk_rollback.result'
--- plugin/transaction_log/tests/r/bulk_rollback.result	2011-01-11 20:37:44 +0000
+++ plugin/transaction_log/tests/r/bulk_rollback.result	2011-01-17 00:17:53 +0000
@@ -71,7 +71,7 @@
       CREATE_TIMESTAMP
       UPDATE_TIMESTAMP
       catalog: "LOCAL"
-      
+      UUID
       version: 1
     }
   }

=== modified file 'plugin/transaction_log/tests/r/ddl_transaction_id.result'
--- plugin/transaction_log/tests/r/ddl_transaction_id.result	2011-01-11 20:37:44 +0000
+++ plugin/transaction_log/tests/r/ddl_transaction_id.result	2011-01-17 00:17:53 +0000
@@ -108,7 +108,7 @@
       CREATE_TIMESTAMP
       UPDATE_TIMESTAMP
       catalog: "LOCAL"
-      
+      UUID
       version: 1
     }
   }

=== modified file 'plugin/transaction_log/tests/r/information_schema.result'
--- plugin/transaction_log/tests/r/information_schema.result	2011-01-11 20:37:44 +0000
+++ plugin/transaction_log/tests/r/information_schema.result	2011-01-17 00:17:53 +0000
@@ -102,7 +102,7 @@
       CREATE_TIMESTAMP
       UPDATE_TIMESTAMP
       catalog: "LOCAL"
-      
+      UUID
       version: 1
     }
   }

=== modified file 'plugin/transaction_log/tests/r/transaction_log_alter.result'
--- plugin/transaction_log/tests/r/transaction_log_alter.result	2011-01-11 20:37:44 +0000
+++ plugin/transaction_log/tests/r/transaction_log_alter.result	2011-01-17 00:17:53 +0000
@@ -118,7 +118,7 @@
       CREATE_TIMESTAMP
       UPDATE_TIMESTAMP
       catalog: "LOCAL"
-      
+      UUID
       version: 1
     }
   }
@@ -215,7 +215,7 @@
       CREATE_TIMESTAMP
       UPDATE_TIMESTAMP
       catalog: "LOCAL"
-      
+      UUID
       version: 1
     }
   }
@@ -381,7 +381,7 @@
       CREATE_TIMESTAMP
       UPDATE_TIMESTAMP
       catalog: "LOCAL"
-      
+      UUID
       version: 1
     }
   }
@@ -644,7 +644,7 @@
       CREATE_TIMESTAMP
       UPDATE_TIMESTAMP
       catalog: "LOCAL"
-      
+      UUID
       version: 1
     }
   }
@@ -942,7 +942,7 @@
       CREATE_TIMESTAMP
       UPDATE_TIMESTAMP
       catalog: "LOCAL"
-      
+      UUID
       version: 1
     }
   }
@@ -1025,7 +1025,7 @@
       CREATE_TIMESTAMP
       UPDATE_TIMESTAMP
       catalog: "LOCAL"
-      
+      UUID
       version: 1
     }
   }
@@ -1282,7 +1282,7 @@
       CREATE_TIMESTAMP
       UPDATE_TIMESTAMP
       catalog: "LOCAL"
-      
+      UUID
       version: 1
     }
   }
@@ -1428,7 +1428,7 @@
       CREATE_TIMESTAMP
       UPDATE_TIMESTAMP
       catalog: "LOCAL"
-      
+      UUID
       version: 1
     }
   }

=== modified file 'plugin/transaction_log/tests/r/transaction_log_create.result'
--- plugin/transaction_log/tests/r/transaction_log_create.result	2011-01-11 20:37:44 +0000
+++ plugin/transaction_log/tests/r/transaction_log_create.result	2011-01-17 00:17:53 +0000
@@ -59,7 +59,7 @@
       CREATE_TIMESTAMP
       UPDATE_TIMESTAMP
       catalog: "LOCAL"
-      
+      UUID
       version: 1
     }
   }
@@ -185,7 +185,7 @@
       CREATE_TIMESTAMP
       UPDATE_TIMESTAMP
       catalog: "LOCAL"
-      
+      UUID
       version: 1
     }
   }
@@ -274,7 +274,7 @@
       CREATE_TIMESTAMP
       UPDATE_TIMESTAMP
       catalog: "LOCAL"
-      
+      UUID
       version: 1
     }
   }
@@ -387,7 +387,7 @@
       CREATE_TIMESTAMP
       UPDATE_TIMESTAMP
       catalog: "LOCAL"
-      
+      UUID
       version: 1
     }
   }
@@ -493,7 +493,7 @@
       CREATE_TIMESTAMP
       UPDATE_TIMESTAMP
       catalog: "LOCAL"
-      
+      UUID
       version: 1
     }
   }
@@ -624,7 +624,7 @@
       CREATE_TIMESTAMP
       UPDATE_TIMESTAMP
       catalog: "LOCAL"
-      
+      UUID
       version: 1
     }
   }
@@ -752,7 +752,7 @@
       CREATE_TIMESTAMP
       UPDATE_TIMESTAMP
       catalog: "LOCAL"
-      
+      UUID
       version: 1
     }
   }
@@ -827,7 +827,7 @@
       CREATE_TIMESTAMP
       UPDATE_TIMESTAMP
       catalog: "LOCAL"
-      
+      UUID
       version: 1
     }
   }
@@ -899,7 +899,7 @@
       CREATE_TIMESTAMP
       UPDATE_TIMESTAMP
       catalog: "LOCAL"
-      
+      UUID
       version: 1
     }
   }
@@ -993,7 +993,7 @@
       CREATE_TIMESTAMP
       UPDATE_TIMESTAMP
       catalog: "LOCAL"
-      
+      UUID
       version: 1
     }
   }
@@ -1093,7 +1093,7 @@
       CREATE_TIMESTAMP
       UPDATE_TIMESTAMP
       catalog: "LOCAL"
-      
+      UUID
       version: 1
     }
   }
@@ -1188,7 +1188,7 @@
       CREATE_TIMESTAMP
       UPDATE_TIMESTAMP
       catalog: "LOCAL"
-      
+      UUID
       version: 1
     }
   }
@@ -1277,7 +1277,7 @@
       CREATE_TIMESTAMP
       UPDATE_TIMESTAMP
       catalog: "LOCAL"
-      
+      UUID
       version: 1
     }
   }
@@ -1394,7 +1394,7 @@
       CREATE_TIMESTAMP
       UPDATE_TIMESTAMP
       catalog: "LOCAL"
-      
+      UUID
       version: 1
     }
   }
@@ -1492,7 +1492,7 @@
       CREATE_TIMESTAMP
       UPDATE_TIMESTAMP
       catalog: "LOCAL"
-      
+      UUID
       version: 1
     }
   }
@@ -1589,7 +1589,7 @@
       CREATE_TIMESTAMP
       UPDATE_TIMESTAMP
       catalog: "LOCAL"
-      
+      UUID
       version: 1
     }
   }
@@ -1924,7 +1924,7 @@
       CREATE_TIMESTAMP
       UPDATE_TIMESTAMP
       catalog: "LOCAL"
-      
+      UUID
       version: 1
     }
   }
@@ -2083,7 +2083,7 @@
       CREATE_TIMESTAMP
       UPDATE_TIMESTAMP
       catalog: "LOCAL"
-      
+      UUID
       version: 1
     }
   }

=== modified file 'plugin/transaction_log/tests/r/transaction_log_schema.result'
--- plugin/transaction_log/tests/r/transaction_log_schema.result	2011-01-13 18:43:55 +0000
+++ plugin/transaction_log/tests/r/transaction_log_schema.result	2011-01-17 00:17:53 +0000
@@ -33,7 +33,7 @@
       catalog: "LOCAL"
       CREATE_TIMESTAMP
       UPDATE_TIMESTAMP
-      
+      UUID
       version: 1
     }
   }
@@ -194,7 +194,7 @@
       catalog: "LOCAL"
       CREATE_TIMESTAMP
       UPDATE_TIMESTAMP
-      
+      UUID
       version: 1
     }
     after {
@@ -206,7 +206,7 @@
       catalog: "LOCAL"
       CREATE_TIMESTAMP
       UPDATE_TIMESTAMP
-      
+      UUID
       version: 2
     }
   }
@@ -290,7 +290,7 @@
       CREATE_TIMESTAMP
       UPDATE_TIMESTAMP
       catalog: "LOCAL"
-      
+      UUID
       version: 1
     }
   }

=== modified file 'plugin/transaction_log/tests/r/transaction_log_transaction.result'
--- plugin/transaction_log/tests/r/transaction_log_transaction.result	2011-01-11 20:37:44 +0000
+++ plugin/transaction_log/tests/r/transaction_log_transaction.result	2011-01-17 00:17:53 +0000
@@ -658,7 +658,7 @@
       CREATE_TIMESTAMP
       UPDATE_TIMESTAMP
       catalog: "LOCAL"
-      
+      UUID
       version: 1
     }
   }

=== modified file 'plugin/transaction_log/tests/t/bulk_check.inc'
--- plugin/transaction_log/tests/t/bulk_check.inc	2010-10-29 02:01:29 +0000
+++ plugin/transaction_log/tests/t/bulk_check.inc	2011-01-14 20:12:02 +0000
@@ -1,3 +1,3 @@
---replace_regex /start_timestamp: [0-9]+/START_TIMESTAMP/g /end_timestamp: [0-9]+/END_TIMESTAMP/g /creation_timestamp: [0-9]+/CREATE_TIMESTAMP/ /update_timestamp: [0-9]+/UPDATE_TIMESTAMP/ /transaction_id: [0-9]+/TRANSACTION_ID/
+--replace_regex /start_timestamp: [0-9]+/START_TIMESTAMP/g /end_timestamp: [0-9]+/END_TIMESTAMP/g /creation_timestamp: [0-9]+/CREATE_TIMESTAMP/ /update_timestamp: [0-9]+/UPDATE_TIMESTAMP/ /uuid: [-a-zA-Z0-9"]+/UUID/ /transaction_id: [0-9]+/TRANSACTION_ID/
 
 SELECT PRINT_TRANSACTION_MESSAGE('transaction.log', ENTRY_OFFSET) FROM DATA_DICTIONARY.TRANSACTION_LOG_ENTRIES;

=== modified file 'plugin/transaction_log/tests/t/check_transaction_log.inc'
--- plugin/transaction_log/tests/t/check_transaction_log.inc	2011-01-13 18:43:55 +0000
+++ plugin/transaction_log/tests/t/check_transaction_log.inc	2011-01-17 00:17:53 +0000
@@ -22,7 +22,7 @@
 SELECT COUNT(*) FROM DATA_DICTIONARY.TRANSACTION_LOG_TRANSACTIONS;
 
 --echo Check transaction log contents
---replace_regex /start_timestamp: [0-9]+/START_TIMESTAMP/g /end_timestamp: [0-9]+/END_TIMESTAMP/g /creation_timestamp: [0-9]+/CREATE_TIMESTAMP/g /update_timestamp: [0-9]+/UPDATE_TIMESTAMP/g /transaction_id: [0-9]+/TRANSACTION_ID/
+--replace_regex /start_timestamp: [0-9]+/START_TIMESTAMP/g /end_timestamp: [0-9]+/END_TIMESTAMP/g /creation_timestamp: [0-9]+/CREATE_TIMESTAMP/g /update_timestamp: [0-9]+/UPDATE_TIMESTAMP/g /uuid: [-a-zA-Z0-9"]+/UUID/g /transaction_id: [0-9]+/TRANSACTION_ID/
 
 SELECT PRINT_TRANSACTION_MESSAGE('transaction.log',(select max(entry_offset) from DATA_DICTIONARY.TRANSACTION_LOG_TRANSACTIONS));
 --echo

=== modified file 'plugin/transaction_log/tests/t/ddl_transaction_id.test'
--- plugin/transaction_log/tests/t/ddl_transaction_id.test	2010-10-28 21:31:13 +0000
+++ plugin/transaction_log/tests/t/ddl_transaction_id.test	2011-01-14 20:12:02 +0000
@@ -5,7 +5,7 @@
 
 --source ../plugin/transaction_log/tests/t/check_transaction_log.inc
 
---replace_regex /start_timestamp: [0-9]+/START_TIMESTAMP/g /end_timestamp: [0-9]+/END_TIMESTAMP/g /creation_timestamp: [0-9]+/CREATE_TIMESTAMP/ /update_timestamp: [0-9]+/UPDATE_TIMESTAMP/ /transaction_id: [0-9]+/TRANSACTION_ID/
+--replace_regex /start_timestamp: [0-9]+/START_TIMESTAMP/g /end_timestamp: [0-9]+/END_TIMESTAMP/g /creation_timestamp: [0-9]+/CREATE_TIMESTAMP/ /update_timestamp: [0-9]+/UPDATE_TIMESTAMP/ /uuid: [-a-zA-Z0-9"]+/UUID/ /transaction_id: [0-9]+/TRANSACTION_ID/
 
 SELECT PRINT_TRANSACTION_MESSAGE('transaction.log',entry_offset) from DATA_DICTIONARY.TRANSACTION_LOG_TRANSACTIONS;
 

=== modified file 'plugin/transaction_log/tests/t/information_schema.test'
--- plugin/transaction_log/tests/t/information_schema.test	2010-10-28 21:31:13 +0000
+++ plugin/transaction_log/tests/t/information_schema.test	2011-01-14 20:12:02 +0000
@@ -15,7 +15,7 @@
 --source ../plugin/transaction_log/tests/t/check_transaction_log.inc
 
 --echo Dump log contents
---replace_regex /start_timestamp: [0-9]+/START_TIMESTAMP/g /end_timestamp: [0-9]+/END_TIMESTAMP/g /creation_timestamp: [0-9]+/CREATE_TIMESTAMP/ /update_timestamp: [0-9]+/UPDATE_TIMESTAMP/ /transaction_id: [0-9]+/TRANSACTION_ID/
+--replace_regex /start_timestamp: [0-9]+/START_TIMESTAMP/g /end_timestamp: [0-9]+/END_TIMESTAMP/g /creation_timestamp: [0-9]+/CREATE_TIMESTAMP/ /update_timestamp: [0-9]+/UPDATE_TIMESTAMP/ /uuid: [-a-zA-Z0-9"]+/UUID/ /transaction_id: [0-9]+/TRANSACTION_ID/
 SELECT PRINT_TRANSACTION_MESSAGE('transaction.log',entry_offset) from DATA_DICTIONARY.TRANSACTION_LOG_TRANSACTIONS;
 
 # Truncate the log file to reset for the next test

=== modified file 'plugin/transaction_log/utilities/transaction_reader.cc'
--- plugin/transaction_log/utilities/transaction_reader.cc	2011-01-10 20:31:03 +0000
+++ plugin/transaction_log/utilities/transaction_reader.cc	2011-01-17 15:51:38 +0000
@@ -50,14 +50,57 @@
 
 static const char *replace_with_spaces= "\n\r";
 
-static void printStatement(const message::Statement &statement, string &output)
+static void printErrorMessage(enum message::TransformSqlError err)
+{
+  switch (err)
+  {
+    case message::MISSING_HEADER:
+    {
+      cerr << "Data segment without a header\n";
+      break;
+    }
+    case message::MISSING_DATA:
+    {
+      cerr << "Header segment without a data segment\n";
+      break;
+    }
+    case message::UUID_MISMATCH:
+    {
+      cerr << "UUID on objects did not match\n";
+      break;
+    }
+    default:
+    {
+      cerr << "Unhandled error\n";
+      break;
+    }
+  }
+}
+
+/**
+ * Transform the given Statement message into a printable SQL string.
+ *
+ * @param[in] statement The Statement protobuf message to transform.
+ * @param[out] output Storage for the printable string.
+ *
+ * @retval true Success
+ * @retval false Error
+ */
+static bool printStatement(const message::Statement &statement, string &output)
 {
   vector<string> sql_strings;
-
-  message::transformStatementToSql(statement,
-                                   sql_strings,
-                                   message::DRIZZLE,
-                                   true /* already in transaction */);
+  enum message::TransformSqlError err;
+
+  err= message::transformStatementToSql(statement,
+                                        sql_strings,
+                                        message::DRIZZLE,
+                                        true /* already in transaction */);
+
+  if (err != message::NONE)
+  {
+    printErrorMessage(err);
+    return false;
+  }
 
   for (vector<string>::iterator sql_string_iter= sql_strings.begin();
        sql_string_iter != sql_strings.end();
@@ -93,6 +136,8 @@
 
     output.append(sql + ";\n");
   }
+  
+  return true;
 }
 
 static bool isEndStatement(const message::Statement &statement)
@@ -284,7 +329,17 @@
   }
 }
 
-static void printTransaction(const message::Transaction &transaction,
+/**
+ * Transform the given Transaction message into printable SQL strings.
+ *
+ * @param[in] transaction The Transaction protobuf message to transform.
+ * @param[in] ignore_events If true, Event messages are not output.
+ * @param[in] print_as_raw If true, print as raw protobuf instead of SQL.
+ *
+ * @retval true Success
+ * @retval false Error
+ */
+static bool printTransaction(const message::Transaction &transaction,
                              bool ignore_events,
                              bool print_as_raw)
 {
@@ -305,13 +360,13 @@
       else
         printEvent(transaction.event());
     }
-    return;
+    return true;
   }
 
   if (print_as_raw)
   {
     transaction.PrintDebugString();
-    return;
+    return true;
   }
 
   size_t num_statements= transaction.statement_size();
@@ -346,8 +401,12 @@
       should_commit= false;
 
     string output;
-    printStatement(statement, output);
-    
+
+    if (not printStatement(statement, output))
+    {
+      return false;
+    }
+
     if (isEndStatement(statement))
     {
       /* A complete, non-segmented statement */
@@ -394,9 +453,11 @@
    */
   if (should_commit)
     cout << "COMMIT;" << endl;
+  
+  return true;
 }
 
-static void processTransactionMessage(TransactionManager &trx_mgr, 
+static bool processTransactionMessage(TransactionManager &trx_mgr, 
                                       const message::Transaction &transaction, 
                                       bool summarize,
                                       bool ignore_events,
@@ -432,7 +493,10 @@
         }
         else
         {
-          printTransaction(new_trx, ignore_events, print_as_raw);
+          if (not printTransaction(new_trx, ignore_events, print_as_raw))
+          {
+            return false;
+          }
         }
         idx++;
       }
@@ -448,12 +512,21 @@
       }
       else
       {
-        printTransaction(transaction, ignore_events, print_as_raw);
+        if (not printTransaction(transaction, ignore_events, print_as_raw))
+        {
+          return false;
+        }
       }
     }
   }
+  
+  return true;
 }
 
+/**
+ * @retval  0 Process completed successfully.
+ * @retval -1 Process encountered an error.
+ */
 int main(int argc, char* argv[])
 {
   GOOGLE_PROTOBUF_VERIFY_VERSION;
@@ -577,8 +650,12 @@
 
       transaction.ParseFromArray(data, length);
 
-      processTransactionMessage(trx_mgr, transaction, 
-                                summarize, ignore_events, print_as_raw);
+      if (not processTransactionMessage(trx_mgr, transaction, 
+                                        summarize, ignore_events,
+                                        print_as_raw))
+      {
+        return -1;
+      }
     }    
   }
   else // file based transaction log 
@@ -610,8 +687,11 @@
       {
         if (opt_transaction_id == transaction_id)
         {
-          processTransactionMessage(trx_mgr, transaction, summarize, 
-                                    ignore_events, print_as_raw);
+          if (not processTransactionMessage(trx_mgr, transaction, summarize, 
+                                            ignore_events, print_as_raw))
+          {
+            return -1;
+          }
         }
         else
         {
@@ -623,8 +703,11 @@
         /*
          * No transaction ID given, so process all messages.
          */
-        processTransactionMessage(trx_mgr, transaction, summarize,
-                                  ignore_events, print_as_raw);
+        if (not processTransactionMessage(trx_mgr, transaction, summarize,
+                                          ignore_events, print_as_raw))
+        {
+          return -1;
+        }
       }  
 
       if (do_checksum)
@@ -646,7 +729,7 @@
     if (error != "EOF")
     {
       cerr << error << endl;
-      return 1;
+      return -1;
     }
   }
 

